<!-- 提前/延迟送检申请列表 -->
<script lang="ts" setup name="InspectionList">
import { reactive, ref } from 'vue'
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import approvalDialog from './ApprovalDialog.vue'
import { cancelApply, delApply, exportApply, getListPage, submitApply } from '@/api/eqpt/measurementPlan/early'
import { SCHEDULE } from '@/utils/scheduleDict'
import { exportFile } from '@/utils/exportUtils'
const $props = defineProps({
  // 申请类型（字典值，提前/延迟）
  approvalType: {
    type: String,
    required: true,
  },
  // 审批状态名字(全部/审批等)
  statusName: {
    type: String,
    required: true,
  },
})
const applyDict = ref<{ [key: string]: string }>({
  审批: '',
  草稿箱: '1',
  审批中: '3',
  已通过: '4',
  未通过: '5',
  已取消: '6',
})
const { proxy } = getCurrentInstance() as any
const listQuery = reactive({
  approvalName: '', // 申请名称
  approvalNo: '', // 申请编号
  createDeptName: '', // 创建单位
  createUserName: '', // 创建人
  createTimeEnd: '', // 结束时间
  createTimeStart: '', // 开始时间
  approvalType: $props.approvalType, // 申请类型（字典值，提前/延迟）
  approvalStatus: '',
  offset: 1,
  limit: 20,
  formId: '',
})
// 设置formid
const setFormID = () => {
  if ($props.approvalType === '0') {
    listQuery.formId = SCHEDULE.METERING_PLAN_EARLY
  }
  else {
    listQuery.formId = SCHEDULE.METERING_PLAN_DEALY
  }
}
setFormID()
// 开始结束时间
const datetimerange = ref()
watch(() => datetimerange.value, (newVal) => {
  listQuery.createTimeStart = ''
  listQuery.createTimeEnd = ''
  if (Array.isArray(newVal)) {
    if (newVal.length) {
      listQuery.createTimeStart = `${newVal[0]} 00:00:00`
      listQuery.createTimeEnd = `${newVal[1]} 23:59:59`
    }
  }
})

const columns = ref([
  {
    text: '申请编号',
    value: 'approvalNo',
    align: 'center',
  },
  {
    text: '申请名称',
    value: 'approvalName',
    align: 'center',
  },
  {
    text: '创建单位',
    value: 'createDeptName',
    align: 'center',
  },
  {
    text: '创建人',
    value: 'createUserName',
    align: 'center',
  },
  {
    text: '创建时间',
    value: 'createTime',
    align: 'center',
  },
])
const list = ref([])
const total = ref(0)
const listLoading = ref(true)

// 获取数据
const fetchData = (isNowPage = true) => {
  list.value = []
  total.value = 0
  listLoading.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.offset = 1
  }
  getListPage(listQuery, $props.statusName).then((response) => {
    list.value = response.data.rows
    total.value = parseInt(response.data.total)
    listLoading.value = false
  }).catch((_) => {
    listLoading.value = false
  })
}
fetchData()
// 查询数据
const search = () => {
  fetchData(false)
}
// 重置搜索条件
const reset = () => {
  datetimerange.value = []
  listQuery.approvalName = ''
  listQuery.approvalNo = ''
  listQuery.createDeptName = ''
  listQuery.createUserName = ''
  listQuery.createTimeEnd = ''
  listQuery.createTimeStart = ''
  listQuery.limit = 20
  listQuery.offset = 1
  search()
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size: number; page: number }) => {
  if (val && val.size) {
    listQuery.limit = val.size
  }
  if (val && val.page) {
    listQuery.offset = val.page
  }
  fetchData()
}
// 表格被选中的行
const selectList = ref<any[]>([])
// 表格多选
const multiSelect = (row: any[]) => {
  selectList.value = row
}
const $router = useRouter()
// 新建编辑操作
const handler = (row: any, type: string) => {
  // 根据申请类型不同去往不同的路由
  // 申请类型（字典值，提前/延迟）
  const params = $props.approvalType === '0' ? 'ealy' : 'delay'
  $router.push({
    path: `/${params}/${type}`,
    query: {
      row: JSON.stringify(row),
      id: row.id,
      approvalType: $props.approvalType, // 申请类型（字典值，提前/延迟）
      statusName: $props.statusName, // statusName
    },
  })
}
// 删除
const delHandler = (row: any) => {
  ElMessageBox.confirm(
    '确认删除该申请吗?',
    '确认',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  ).then(() => {
    delApply({ id: row.id }).then((res) => {
      ElMessage.success('操作成功')
      search()
    })
  })
}
// 详情
const detail = (row: any) => {
  if ($props.statusName === '草稿箱' || $props.statusName === '未通过' || $props.statusName === '已取消') {
    handler(row, 'update')
  }
  else {
    const params = $props.approvalType === '0' ? 'ealy' : 'delay'
    $router.push({
      path: `${params}/detail`,
      query: {
        row: JSON.stringify(row),
        id: row.id,
        approvalType: $props.approvalType, // 申请类型（字典值，提前/延迟）
        statusName: $props.statusName, // statusName
      },
    })
  }
}
// 取消
const canHandler = (row: any) => {
  ElMessageBox.confirm(
    '确认取消此申请吗?',
    '确认',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  ).then(() => {
    cancelApply({ id: row.id, processInstanceId: row.processId, comments: '' }).then((res) => {
      ElMessage.success('操作成功')
      // close()
      search()
    })
  })
}
// 提交
const submit = (row: any) => {
  ElMessageBox.confirm(
    '确认提交吗？',
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  ).then((res) => {
    submitApply({ id: row.id, formId: $props.approvalType === '0' ? SCHEDULE.METERING_PLAN_EARLY : SCHEDULE.METERING_PLAN_DEALY }).then((res) => {
      ElMessage.success('已提交')
      search()
    })
  })
}
// 同意拒绝
const approvalDialogRef = ref()
const approveHandler = (row: any, type: string) => {
  approvalDialogRef.value.initDialog(type, row.taskId, row.processId, row.id)
}
// 导出列表
const exportList = () => {
  if (list.value.length) {
    const loading = ElLoading.service({
      lock: true,
      text: 'Loading',
      background: 'rgba(255, 255, 255, 0.8)',
    })
    const data = {
      ...listQuery,
      offset: undefined,
      limit: undefined,
      ids: selectList.value.map(item => item.id),
    }
    exportApply(data).then((res) => {
      exportFile(res.data, $props.approvalType === '0' ? '提前送检申请' : '延迟送检申请')
      loading.close()
    })
      .catch((_) => {
        loading.close()
      })
  }
  else {
    ElMessage.warning('无可导出内容')
  }
}
// 审批状态发生变化
watch(() => $props.statusName, (newVal) => {
  if (newVal) {
    listQuery.approvalStatus = applyDict.value[newVal] as string
    fetchData()
  }
},
{
  deep: true,
  immediate: true,
})
const permUrl = ref({
  edit: '/tested/pmetering/plan/edit',
  del: '/tested/pmetering/plan/delete',
  submit: '/tested/pmetering/plan/submit',
  cancel: '/tested/pmetering/plan/cancel',
  agree: '/tested/pmetering/plan/agree',
  reject: '/tested/pmetering/plan/reject',
})
</script>

<template>
  <app-container>
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="search" @clear="reset">
      <!-- 审批弹窗 -->
      <approval-dialog ref="approvalDialogRef" @on-success="search" />
      <search-item>
        <el-input v-model.trim="listQuery.approvalNo" placeholder="申请编号" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.approvalName" placeholder="申请名称" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.createDeptName" placeholder="创建单位" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.createUserName" placeholder="创建人" clearable />
      </search-item>
      <search-item>
        <el-date-picker
          v-model="datetimerange" type="daterange" value-format="YYYY-MM-DD"
          format="YYYY-MM-DD" range-separator="至" start-placeholder="创建开始时间" end-placeholder="创建结束时间"
        />
      </search-item>
    </search-area>
    <table-container>
      <template v-if="$props.statusName === '全部'" #btns-right>
        <icon-button icon="icon-add" title="新增" @click="handler({}, 'create')" />
        <icon-button icon="icon-export" title="导出" @click="exportList" />
      </template>
      <!-- 普通表格 -->
      <normal-table
        :data="list" :total="total" :columns="columns" :query="listQuery" :list-loading="listLoading" :is-multi="true"
        :is-showmulti-select="true" @change="changePage" @multi-select="multiSelect"
      >
        <template #columns>
          <el-table-column v-if="$props.statusName !== '全部'" label="审批状况" align="center">
            <template #default="scope">
              <span> {{ scope.row.approvalStatusName }}</span>
            </template>
          </el-table-column>
          <el-table-column label="操作" width="160" align="center">
            <template #default="scope">
              <el-button link type="primary" size="small" @click="detail(scope.row)">
                查看
              </el-button>
              <el-button
                v-if="proxy.buttonPerm.edit.if({ approvalStatusName: $props.statusName }, permUrl.edit) && $props.statusName !== '全部'" link type="primary" size="small"
                @click="handler(scope.row, 'update')"
              >
                编辑
              </el-button>
              <el-button
                v-if="proxy.buttonPerm.agree.if({ approvalStatusName: $props.statusName }, permUrl.agree)" link type="primary" size="small"
                @click="approveHandler(scope.row, 'agree')"
              >
                同意
              </el-button>
              <el-button
                v-if="proxy.buttonPerm.reject.if({ approvalStatusName: $props.statusName }, permUrl.reject)" link type="primary" size="small"
                @click="approveHandler(scope.row, 'refuse')"
              >
                拒绝
              </el-button>
              <el-button
                v-if="proxy.buttonPerm.submit.if({ approvalStatusName: $props.statusName }, permUrl.submit)" link type="primary" size="small"
                @click="submit(scope.row)"
              >
                提交
              </el-button>
              <el-button
                v-if="proxy.buttonPerm.cancel.if({ approvalStatusName: $props.statusName }, permUrl.cancel)" link type="primary" size="small"
                @click="canHandler(scope.row)"
              >
                取消
              </el-button>
              <el-button
                v-if="proxy.buttonPerm.delete.if({ approvalStatusName: $props.statusName }, permUrl.del) && $props.statusName !== '全部'" link type="danger" size="small"
                @click="delHandler(scope.row)"
              >
                删除
              </el-button>
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>
  </app-container>
</template>

